clear, clc, mode(0), close(winsid()) 
/// //// $y_t=b_0v_{1;t}+c_0v_{2;t}+a_1y_{t-1}+b_1v_{1;t-1}+c_1v_{2;t-1}+e_t$

data=csvRead('data_cv8.csv',';');
y=data(:,1); //// rychlost auta v koloně ve městě
v1=data(:,2); //// rychlost vpředu jedoucího vozidla
v2=data(:,3); //// vzdálenost mezi vozidly

nd=size(y,1);   /// počet dat
np=5;

//////////////////////Odhadování 
nps=5+1;    //rozměr informační matice V
V=0.001*eye(nps,nps);    //počáteční informační matice V
k=0;                 //počáteční počítadlo k
theta_odhad=rand(5,1,'n');   ///náhodný počáteční odhad regresních koeficientů




//////////////Vícekroková predikce
for t=4:(nd-np)
    yy(1:(t-1))=y(1:(t-1)); //uložíme stará data
    for i=0:np
        ps=[v1(t+i) v2(t+i) yy(t+i-1) v1(t+i-1) v2(t+i-1)]; //regresní vektor
        yy(t+i)=ps*theta_odhad; //generujeme střední hodnotu predikce
    end
    yp(t+np)=yy(t+np)  ;       //uložíme vícekrokovou predikci
    
    Ps=[y(t) v1(t) v2(t) y(t-1) v1(t-1) v2(t-1)];
    V=V+Ps'*Ps;        //update informační matice
    k=k+1;             //update počítadla
    
    //rozklad informační matice V
    Vy=V(1,1);        // část Vy 
    Vyps=V(2:$,1);   // část Vyps
    Vps=V(2:$,2:$);  //část Vps

    //bodové odhady
    theta_odhad=inv(Vps)*Vyps;  ///bodové odhady regresních koeficientů
    theta_ulozit(:,t)=theta_odhad;         
end


////Výsledky
disp(' Odhad parametrů:')
disp(theta_odhad)


// Chyba predikce
RMSE=sqrt(mean((y((np+4):nd) - yp((np+4):nd)).^2));
disp('RMSE: '+string(RMSE))


scf(1);
plot(theta_ulozit');
title('Vývoj odhadů regresních koeficientů','fontsize',5);
legend('b0','c0','a1','b1','c1'); 
xlabel('Čas','fontsize',4);
ylabel('Odhady regresních koeficientů','fontsize',4);

scf(2);
plot(y,'b');
plot(yp,'r');
legend('rychlost','predikce',4);
title([string(np)+'-kroková predikce rychlosti'],'fontsize',5);
xlabel('Čas','fontsize',4);
ylabel('Rychlost (km/h)','fontsize',4);
